; TSR with no PSP (c) 2017 by Jin X
; ⠭ १ ࠡ稪 뢠,  쭮 -  (஢ ⮫쪮, ᪮쪮 ॡ + 16   MCB),  PSP !!!

.MODEL Tiny
.286
.CODE
.STARTUP

IFDEF		??Version			; TASM
  LOCALS
ENDIF

;   ⠭ 묨 㤮묨  祭ﬨ
MuxFunc		=	0F1h			;  㭪樨 MUX Interrupt (Int 2Fh),      0C0h  0FFh
MuxAuthorID	=	'xx'			; 䨪  (BX)
MuxProgID	=	'tt'			; 䨪 ணࠬ (DX)
MuxAnswer	=	77FFh			; ⢥  AX, ᫨ ணࠬ ⠭ ( 祭)

ProgStart	=	offset $		; 砫 襩 ணࠬ

		call	PreCheck		; 3  - ।⥫쭠 ஢ઠ (,  㦥   ?)
		
		mov	ah,49h			; 2 
		mov	es,ds:[2Ch]		; 4 
		int	21h			; 2  - ᢮ ६ 㦥

		; 뤥塞   襣 १
		mov	ah,48h			; 2 

		jmp	TSRInstall		; 2-3 , ⮣ 15-16  - 룠  த ⠭騪

EVEN						;   16 , ᫨ jmp  ⪨ (2-⮢ short)

;-- 砫 १⭮  ࠡ稪 뢠 -------------------------------------------------------------------
;  ⪠   ஢  ࠭ ࠣ (16 ) !!!
TSRStart:

;  १⭮ 
VentilChars	DB	'|/-\'			; ⠡ ᨬ (⨫)
VentilOfs	DB	-1			;  ।饣 ᨬ (稭  0)
VentilColor	DB	1Eh			; 梥 ⨫

; ࠡ稪 뢠 8 (⥬ ⠩)
HandlerInt8	PROC
		push	ax
		push	bx
		push	ds
		
		push	cs
		pop	ds
		mov	al,[VentilOfs]
		inc	ax
		and	al,3
		mov	[VentilOfs],al		;  ᬥ饭
		mov	bx,offset VentilChars
		xlat				; AL = ᨬ
		mov	ah,[VentilColor]	; AH = 梥 ⨫
		push	0B800h
		pop	ds
		mov	ds:[0],ax		; 뢮 ᨬ   孨 㣮

		pop	ds
		pop	bx
		pop	ax
  OldInt8:
		DB	0EAh			; 頥 ࠢ 뢠
  OldAddr8	DW	?,?			;  뢠
HandlerInt8	ENDP

; ࠡ稪 뢠 9 ()
HandlerInt9	PROC
		push	ax
		in	al,60h			; ⠥ ᪠- ⮩ 
		cmp	al,39h			; ஡?
		jne	@@CheckEnter

		; ᫨ ஡, 塞 ⠬ ᨬ ⨫ (塞 ࠢ 饭)
		mov	ax,word ptr cs:[VentilChars]
		xchg	al,ah
		xchg	ax,word ptr cs:[VentilChars+2]
		xchg	al,ah
		mov	word ptr cs:[VentilChars],ax
		jmp	@@exit
	@@CheckEnter:
		cmp	al,1Ch			; Enter?
		jne	@@exit
		xor	byte ptr cs:[VentilColor],(1Eh xor 21h)	; ᫨ Enter, 塞 梥
	@@exit:
		pop	ax
  OldInt9:
		DB	0EAh			; 頥 ࠢ 뢠
  OldAddr9	DW	?,?			;  뢠
HandlerInt9	ENDP

; ࠡ稪 뢠 2Fh (MUX Interrupt)
HandlerInt2F	PROC
		cmp	ah,MuxFunc		; ஢塞  㭪樨
		jne	OldInt2F
		cmp	bx,MuxAuthorID		; ஢塞 䨪 
		jne	OldInt2F
		cmp	dx,MuxProgID		; ஢塞 䨪 ணࠬ
		jne	OldInt2F

		test	al,al			; ஢塞  㭪樨
		jne	@@WrongFunc

		mov	ax,MuxAnswer		; ᫨ AL=0, 頥  ⢥
		iret

	@@WrongFunc:
		xor	ax,ax			; ᫨  㭪樨 , 頥 0  AX
		iret

  OldInt2F:
		DB	0EAh			; 頥 ࠢ 뢠
  OldAddr2F	DW	?,?			;  뢠
HandlerInt2F	ENDP

TSREnd		=	$			;  १⭮  (   묨)

;-----------------------------------------------------------------------------------------------------------------------

TSRSize		=	TSREnd-TSRStart		; ࠧ १⭮ 
TSRParaSize	=	(TSRSize+15)/16		; ࠧ १⭮   ࠣ

;    墠뢠 뢠
TSRItem		STRUC
  TSRIntNo	DB	?			;  뢠
  TSRAddrOfs	DW	?			; ᬥ饭 ६  ᮬ ண ࠡ稪
  TSRHandlerOfs	DW	?			; ᬥ饭 襣 ࠡ稪 뢠
TSRItem		ENDS

;  뢠, ᮢ ࠡ稪  ६  ࠭  ᮢ
TSRTables	TSRItem	<8,OldAddr8,HandlerInt8>, <9,OldAddr9,HandlerInt9>, <2Fh,OldAddr2F,HandlerInt2F>
TSRIntCount	=	($-TSRTables)/(size TSRItem)

;-----------------------------------------------------------------------------------------------------------------------

; ஢ઠ -   㦥    ?
; ᫨ ,  室  ணࠬ (int 20h)
PreCheck	PROC
		mov	ax,MuxFunc shl 8
		mov	bx,MuxAuthorID
		mov	dx,MuxProgID
		int	2Fh			; ஢塞  ணࠬ

		cmp	ax,MuxAnswer
		jne	@@NotInstalled		; 룠, ᫨  ⠭

		mov	ah,9
		mov	dx,offset MsgTSRAlrInst
		int	21h			; 뢮 ᮮ饭

		int	20h			; 室  ணࠬ
	@@NotInstalled:
		ret
PreCheck	ENDP

; ⠭ १⭮   墠 뢠
TSRInstall	PROC
		cld				; ⠭ אַ 冷 ࠡ⪨ ப ( 饥)

		mov	bx,TSRParaSize
		int	21h			; 뤥塞  㦭  ࠧ
		jnc	@@Allocated		; ᫨  뤥,   墠!

		; ७ᨬ   , ᢮  ⥪饣  (⮡ 뤥   襬   १⭮ )
		mov	sp,offset @Startup+ProgParaSize*16+100h	; ४㥬 SP (⠢塞  ⥪ 256 )
		
		mov	ah,4Ah
		push	cs
		pop	es
		mov	bx,ProgParaSize+20h	; - ࠣ䮢,  PSP  ⥪
		int	21h			; ᦨ ࠧ 뤥 襩 ணࠬ  
		jc	@@Error			; 訡...   ।?

		mov	ah,48h
		int	21h			; 뤥塞   ⠪  
		jc	@@Error			; 訡... 㦥    ⠪   ?

		mov	es,ax			; ES =   
		xor	si,si
		xor	di,di
		mov	cx,(ProgEnd-@Startup+100h+1)/2
		rep movsw			; 㥬     

		push	es
		pop	ss			; 塞 SS  

		push	es
		push	offset @@Continue
		retf				; 룠    :)
	@@Continue:
		mov	ah,50h
		mov	bx,es
		int	21h			; ⠭  PSP

		mov	ah,49h
		push	ds
		pop	es			; ES =  PSP
		int	21h			; ᢮ ,    ࠭

		push	cs
		pop	ds			; DS =   (⥪騩) PSP

		mov	ah,48h
		mov	bx,TSRParaSize
		int	21h			;  ࠧ ⠥ 뤥  㦭  ࠧ
		jc	@@Error			; 訡...   ।?

	@@Allocated:
		; ७ᨬ    뤥 
		sub	ax,(TSRStart-@Startup+100h)/16
		mov	es,ax			; ES = ᥣ १⭮ 
		mov	si,offset TSRStart
		mov	di,si
		mov	cx,(TSRSize+1)/2
		rep movsw			; 㥬  १   뤥 

		mov	word ptr es:[TSRStart-0Fh],40h	; 砥  MCB 뤥 ⮪  ਭ騩 ᥣ 40h ( ᥣ ਭ BIOS    㤥 ᢮)

		; 墠 뢠
		mov	si,offset TSRTables
IF	TSRIntCount gt 1
		mov	cx,TSRIntCount
	@@SetTSRLoop:
ENDIF
		lodsb				; ⠥  뢠
		push	ax
		push	es
		mov	ah,35h
		int	21h			; 砥  ࠡ稪  ES:BX
		mov	dx,es			; ࠭塞 ᥣ  DX
		pop	es
		lodsw
		xchg	di,ax			; DI =  ६
		xchg	ax,bx
		stosw				; 뢠   ᬥ饭
		xchg	ax,dx
		stosw				;  ᥣ

		lodsw
		xchg	dx,ax			; DX =  襣 ࠡ稪
		pop	ax			; ⠭  뢠
		mov	ah,25h
		push	ds
		push	es
		pop	ds			; DS = ES = ᥣ १⭮ 
		int	21h			; ⠭  ࠡ稪
		pop	ds

IF	TSRIntCount gt 1
		loop	@@SetTSRLoop		; 塞 横
ENDIF
		mov	dx,offset MsgTSRInstOk	; ᮮ饭,   ok
	@@Message:
		mov	ah,9
		int	21h			; 뢮 ᮮ饭

		int     20h			; 室  ணࠬ (int 27h    㦥, .. १  室  ⮭  , 㦥  易  ⥪饩 ணࠬ) :)

	@@Error:
		mov	dx,offset MsgTSRInstErr	; ᮮ饭  訡
		jmp	@@Message

TSRInstall	ENDP

;-----------------------------------------------------------------------------------------------------------------------

; 饭
MsgTSRInstOk	DB	'TSR is successfully installed !!!',13,10,'$'
MsgTSRAlrInst	DB	'TSR is already installed !!!',13,10,'$'
MsgTSRInstErr	DB	'TSR installation is failed :(',13,10,'$'

ProgEnd		=	$			;  ᥩ 襩 ணࠬ
ProgParaSize	=	(ProgEnd-@Startup+15)/16	; ࠧ ᥩ 襩 ணࠬ ( PSP)  ࠣ

END
